//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fstruncatechain.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"



// REDUCE FAT CHAIN IF NOT NEEDED

int FSTruncateChain(FS_FILE *file, int newsize)
{
FS_FRAGMENT *ch,*ch2;
int clsize,size=0,addr,fullsize;
FS_VOLUME *fs=FSystem.Volumes[file->Volume];

ch=&file->Chain;
//printf("truncate newsize=%d\n",newsize);
if(!ch->StartAddr) return FS_OK;

clsize=(1<<fs->ClusterSize)-1;

newsize+=clsize;
newsize&=~clsize;		// ROUND TO CLUSTERS

fullsize=FSGetChainSize(ch);

if(newsize>=fullsize) return FS_OK;

++clsize;

while(ch) {
size+=ch->EndAddr-ch->StartAddr;
if(size>=newsize) break;
ch=ch->NextFragment;
}

// FOUND LAST FRAGMENT
if(size==newsize) {
// FRAGMENT FITS EXACTLY
if(FSWriteFATEntry(FSAddr2Cluster(ch->EndAddr,fs)-1,0xfffffff,fs)!=FS_OK) return FS_ERROR;	// MARK LAST CLUSTER AS END-OF-CHAIN

} else {
if(size>newsize) {
// TRUNCATE CHAIN
addr=ch->EndAddr-(size-newsize);
if(newsize) {
if(FSWriteFATEntry(FSAddr2Cluster(addr,fs)-1,0xfffffff,fs)!=FS_OK) return FS_ERROR;	// MARK LAST CLUSTER AS END-OF-CHAIN
}
else {
ch->StartAddr=0;		// CHAIN IS NOT ALLOCATED
file->FirstCluster=0;
}
while(addr!=ch->EndAddr) {
if(FSWriteFATEntry(FSAddr2Cluster(addr,fs),0,fs)!=FS_OK) return FS_ERROR;	// MARK CLUSTERS AS FREE
addr+=clsize;
}
ch->EndAddr-=size-newsize;
}
}


// FREE THE REST OF THE CLUSTER CHAIN

ch2=ch->NextFragment;
ch->NextFragment=NULL;

while(ch2) {
addr=ch2->StartAddr;
while(addr!=ch2->EndAddr) {
FSWriteFATEntry(FSAddr2Cluster(addr,fs),0,fs);	// MARK CLUSTERS AS FREE
addr+=clsize;
}
ch=ch2;
ch2=ch2->NextFragment;
free(ch);
}


fs->FreeSpace-=newsize-fullsize;
return FS_OK;

}


