//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

#include <hpgcc3.h>
extern "C" {
#include <ggl.h>
}

#include "memblock.h"
#include "gstring.h"
#include "gui.h"
#include "resources.h"



// CLASS CHECKBOX

gCheckBox::gCheckBox(gControl& _Parent,int x, int y,gStyles Type)
: gControl(_Parent)
{
	posx=x;
	posy=y;
	sizex=8;
	sizey=6;
	TypeFlags=Type;
	State=0;
}

gCheckBox::~gCheckBox()
{
	
}


void gCheckBox::SetState(int state)
{
	gUpdate u;
	if(State&S_FOCUSED) State=state | S_FOCUSED;
	else State=state&(~S_FOCUSED);
	
	DrawCheck(State);
	
	u.clipx=posx;
	u.clipy=posy;
	u.clipx2=posx+sizex-1;
	u.clipy2=posy+sizey-1;
	Parent->Invalidate(&u,this);
}


int gCheckBox::GetState() { return State; }

void gCheckBox::Update(gUpdate *u)
{
	DrawCheck(State);
}


BOOL gCheckBox::DefaultEvent(gEvent *e)
{
	gUpdate u;
	gEvent ev;

	if(e->Type==GEVENT_KEYB) {

		// IMPLEMENT BASIC KEYBOARD HANDLING
		switch(e->Arg)
		{
		case KM_PRESS | KB_W:
		case KM_PRESS | KB_SPC:
		ev.Type=GEVENT_GUI;
		ev.Arg=GEVGUI_BEFORECHECK;
		ev.Data=(State^TypeFlags)&(~S_FOCUSED);
		if(DoEventExclusive(&ev))
			{
			if(ev.Data!=0) {	// IF TRUE, ALLOW THE CHANGE TO HAPPEN
				State^=TypeFlags; // ALTERNATE STATES
				ev.Type=GEVENT_GUI;
				ev.Arg=GEVGUI_AFTERCHECK;
				ev.Data=State&(~S_FOCUSED);
				DoEventExclusive(&ev);
			}
			} else {		
		State^=TypeFlags; // ALTERNATE STATES
		ev.Type=GEVENT_GUI;
		ev.Arg=GEVGUI_AFTERCHECK;
		ev.Data=State&(~S_FOCUSED);
		DoEventExclusive(&ev);
		}
		u.clipx=posx;
		u.clipy=posy;
		u.clipx2=posx+sizex-1;
		u.clipy2=posy+sizey-1;
		Parent->Invalidate(&u,this);
		return TRUE;

		}

	}
	
	if(e->Type==GEVENT_GUI) {
		switch(e->Arg)
		{
		case GEVGUI_GETFOCUS:
			State|=S_FOCUSED;
			u.clipx=posx;
			u.clipy=posy;
			u.clipx2=posx+sizex-1;
			u.clipy2=posy+sizey-1;
			Parent->Invalidate(&u,this);
			return TRUE;
		case GEVGUI_LOSEFOCUS:
			State&=~S_FOCUSED;
			u.clipx=posx;
			u.clipy=posy;
			u.clipx2=posx+sizex-1;
			u.clipy2=posy+sizey-1;
			Parent->Invalidate(&u,this);
			return TRUE;
			
			
		}
		
	}
	return FALSE;

	
}


void gCheckBox::DrawCheck(int state)
{
	int sx=8*(state&(~S_FOCUSED));
	if(sx>40) sx=0;
	if(sx<0) sx=0;
	
	Parent->DrawIconPartial(posx,posy,iCheckBox,48,sx,0,8,6);
	if(state&S_FOCUSED) {
		Parent->HLine(posy,posx,posx+sizex-1,GGRAY7);
		Parent->VLine(posx,posy+1,posy+sizey-1,GGRAY7);
	}
	
}

