//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include "hpgraphics.h"
#include "hpgpriv.h"

void hpg_draw_circle_on(hpg_t *g, int cx, int cy, int r)
{
    hpg_init();
    if(g==NULL) g=HPG_STDSCREEN;
    int x, y, d;

    d = 3 - (2 * r);
    x = 0;
    y = r;

    while (x <= y)
    {
        _hpg_draw(g, cx + x, cy + y, 1, -1, -1);
        _hpg_draw(g, cx + x, cy - y, 1, -1, -1);

        if (x != 0)
        {
            _hpg_draw(g, cx - x, cy + y, 1, -1, -1);
            _hpg_draw(g, cx - x, cy - y, 1, -1, -1);
        }

        if (x != y)
        {
            _hpg_draw(g, cx + y, cy + x, 1, -1, -1);
            _hpg_draw(g, cx - y, cy + x, 1, -1, -1);

            if (x != 0)
            {
                _hpg_draw(g, cx + y, cy - x, 1, -1, -1);
                _hpg_draw(g, cx - y, cy - x, 1, -1, -1);
            }
        }

        if (d < 0)
        {
            d += 4 * x + 6;
        }
        else
        {
            d += 4 * (x - y) + 10;
            y--;
        }

        x++;
    }
}
