//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

#include <hpgcc3.h>
#include <master_globals.h>
#include <system_globals.h>


#define HWREG(base,off) ( (volatile unsigned int *) (((int)base+(int)off)))


void __irq_dummy(void)
{
	return;
}

void __irq_service() __attribute__ ((naked));
void __irq_service()
{
	asm volatile ("stmfd sp!, {r0-r12,lr}");
	
	(*( (__interrupt__) (__sg->irq_table[*HWREG(INT_REGS,0x14)]))) ();
	// CLEAR INTERRUPT PENDING FLAG
	register unsigned int a=1<<(*HWREG(INT_REGS,0x14));
	*HWREG(INT_REGS,0x0)=a;
	*HWREG(INT_REGS,0x10)=a;
	
	asm volatile ("ldmia sp!, {r0-r12,lr}");
	asm volatile ("subs pc,lr,#4");
}


void __irq_install()
{
int f;

// SET ALL IRQ SERVICES TO DUMMY
for(f=0;f<32;++f)
{
	__sg->irq_table[f]=(unsigned int)&__irq_dummy;
}
	
// HOOK INTERRUPT SERVICE ROUTINE
// ORIGINAL SAVED W/EXCEPTION HANDLERS
*( (unsigned int *) 0x08000018)=(unsigned int)&__irq_service;
	
}

void __irq_addhook(int service_number,__interrupt__ serv_routine)
{
	if(service_number<0 || service_number>31) return;
	__sg->irq_table[service_number]=(unsigned int)serv_routine;
}

void __irq_releasehook(int service_number)
{
	if(service_number<0 || service_number>31) return;
	__sg->irq_table[service_number]=(unsigned int)&__irq_dummy;
}


