//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***




#include <hpgcc3.h>

void xr_mul(XREAL *num1,XREAL *num2,XREAL *result)
{
	union {
	unsigned long long mant;
	struct { unsigned int lo,hi; } ;
	} amant,bmant;
	unsigned int resmant[4];
	unsigned long long *lo,*mid,*hi,temp,temp2;
	

	result->Sign=num1->Sign^num2->Sign;

	// HANDLE SPECIAL NUMBERS
	if(num1->Exp==(1<<29)) {
	if(num1->Mant) {
	// +/- INF
	if(num2->Mant==0) {
	// NUM2 IS EITHER 0 OR NAN, RETURN NAN
	result->Mant=0;
	result->Exp=(1<<29);
	return;	
	}
	else {
	// INF*NUMBER OR INF*INF = INF
	result->Mant=-1LL;
	result->Exp=(1<<29);
	return;
	}
	
	}
	else {
	// +/- NAN
	result->Mant=0;
	result->Exp=(1<<29);
	return;	
	}
	
	}
	
	if(num2->Exp==(1<<29)) {
	if(num2->Mant) {
	// +/- INF
	if(num1->Mant==0) {
	// NUM1 IS 0, RETURN NAN
	result->Mant=0;
	result->Exp=(1<<29);
	return;	
	}
	else {
	// INF*NUMBER = INF
	result->Mant=-1LL;
	result->Exp=(1<<29);
	return;
	}
	
	}
	else {
	// +/- NAN
	result->Mant=0;
	result->Exp=(1<<29);
	return;	
	}
	
	}

	// CHECK MULTIPLY BY ZERO
	if( (num1->Mant==0) || (num2->Mant==0)) {
		result->Sign=0;
		result->Mant=0;
		result->Exp=-63;
		return;	
	}

	result->Exp=num1->Exp+num2->Exp+64;

	amant.mant=num1->Mant;
	bmant.mant=num2->Mant;

	lo=(unsigned long long *) ((int *) (&resmant[0]));
	mid=(unsigned long long *) ((int *) (&resmant[1]));
	hi=(unsigned long long *) ((int *) (&resmant[2]));


	*hi=0;
	*lo=(unsigned long long)amant.lo*(unsigned long long)bmant.lo;
	temp=(unsigned long long)amant.lo*(unsigned long long)bmant.hi;
	temp2=(unsigned long long)amant.hi*(unsigned long long)bmant.lo;
	*mid+=(temp&0xffffffff)+(temp2&0xffffffff);	// ENSURE CARRY IS PROPERLY PROPAGATED
	*hi+=(temp>>32)+(temp2>>32);
	*hi+=(unsigned long long)amant.hi*(unsigned long long)bmant.hi;

	if((*hi | *lo)!=0) {
		while( !(*hi>>63)) {
		// NEEDS NORMALIZATION
		*hi=(*hi<<1) | (*lo>>63);
		*lo<<=1;
		result->Exp--;
		
	}
	}
	
	if(resmant[1]&0x80000000) {
	// ROUND LAST DIGIT UP
		++*hi;
		if(!resmant[3]) {
			resmant[3]=0x80000000;
			result->Exp++;
		}
	}
	result->Mant=*hi;
return;
}
