//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include <stdlib.h>

// Simpliest version that works
// SLOWEST version that works !

/*
void *memcpy(void *_dest, const void *_source, size_t nbytes)
{
    register char *dest= (char *) _dest;
    register char *source= (char *) _source;
    while(nbytes--) 
        *dest++=*source++;
    
    
    return _dest;
}
*/


/*
void *memcpy(void *_dest, const void *source, size_t nbytes)
{
    register void *dest=_dest;
    while(nbytes&3) 
    {
        *((char *)dest)=*((char *)source);
        ++((char *)dest);
        ++((char *)source);
        --nbytes;
    }
    while(nbytes>=4) 
    {
        *((int *)dest)=*((int *)source);
        ++((int *)dest);
        ++((int *)source);
        --nbytes;
    }
    while(nbytes) 
    {
        *((char *)dest)=*((char *)source);
        ++((char *)dest);
        ++((char *)source);
        --nbytes;
    }
    return _dest;
}
*/


// FASTEST that works

// ROMLIB CHECKED

void *
memcpy(void *trg, const void *src, size_t n)
{
    void *r  = trg;
    char *t8 = (char *) trg;
    char *s8 = (char *) src;
    
    #define ESIZE sizeof(size_t)
    #define CSIZE (4*ESIZE)
    
    if (n >= CSIZE &&  ! ( ((unsigned)t8 & (ESIZE-1)) || ((unsigned)s8 & (ESIZE-1)) ) ) {
    
        // source & target properly aligned
        // use word copy...
    
        size_t *T,*S;
    
        
        T = (size_t *) t8;
        S = (size_t *) s8;
        
        for (; n >= CSIZE ;) {
            *T++ = *S++;
            *T++ = *S++;
            *T++ = *S++;
            *T++ = *S++;
            n -= CSIZE;
        }
            
        for (; n >= ESIZE ;) {
            *T++ = *S++;
            n -= ESIZE;
        }
        
        if ( n > 0 ) {
            
            t8 = (char *) T;
            s8 = (char *) S;
                
            for (; n-- ;)
                *t8++ = *s8++;
        }
    }
    else if(n > 0) 
        for (; n-- ;)
            *t8++ = *s8++;
    
        
    return r;
}



